#include <system/System.hpp>
#include <idt/Idt.hpp>
#include <idt/InterruptRoutines.hpp>
#include <bios/Video.hpp>

extern "C" void _irout0();
extern "C" void _irout1();
extern "C" void _irout2();
extern "C" void _irout3();
extern "C" void _irout4();
extern "C" void _irout5();
extern "C" void _irout6();
extern "C" void _irout7();
extern "C" void _irout8();
extern "C" void _irout9();
extern "C" void _irout10();
extern "C" void _irout11();
extern "C" void _irout12();
extern "C" void _irout13();
extern "C" void _irout14();
extern "C" void _irout15();
extern "C" void _irout16();
extern "C" void _irout17();
extern "C" void _irout18();
extern "C" void _irout19();
extern "C" void _irout20();
extern "C" void _irout21();
extern "C" void _irout22();
extern "C" void _irout23();
extern "C" void _irout24();
extern "C" void _irout25();
extern "C" void _irout26();
extern "C" void _irout27();
extern "C" void _irout28();
extern "C" void _irout29();
extern "C" void _irout30();
extern "C" void _irout31();

static const char* exception_messages[] = {
		"Dividing by zero", // 0
		"Debug exception",
		"Non-maskable interrupt exception",
		"Breakpoint exception",
		"Detected overflow",
		"Out of bounds",
		"Invalid operation code",
		"No coprocessor",
		"Double fault",
		"Coprocessor segment overrun",
		"Bad TSS exception", // 10
		"Segment not present", "Stack fault", "General protection fault",
		"Page fault", "Unknown interrupt",
		"Coprocessor fault",
		"Alignment check exception",
		"Machine check exception",
		"Reserved exception",
		"Reserved exception", // 20
		"Reserved exception", "Reserved exception", "Reserved exception",
		"Reserved exception", "Reserved exception", "Reserved exception",
		"Reserved exception", "Reserved exception", "Reserved exception",
		"Reserved exception", //  30
		"Reserved exception" };

void InterruptRoutines::install(Idt &idt) {
	idt.createIdtGate(0, (unsigned) _irout0, 0x08, 0x8E);
	idt.createIdtGate(1, (unsigned) _irout1, 0x08, 0x8E);
	idt.createIdtGate(2, (unsigned) _irout2, 0x08, 0x8E);
	idt.createIdtGate(3, (unsigned) _irout3, 0x08, 0x8E);
	idt.createIdtGate(4, (unsigned) _irout4, 0x08, 0x8E);
	idt.createIdtGate(5, (unsigned) _irout5, 0x08, 0x8E);
	idt.createIdtGate(6, (unsigned) _irout6, 0x08, 0x8E);
	idt.createIdtGate(7, (unsigned) _irout7, 0x08, 0x8E);
	idt.createIdtGate(8, (unsigned) _irout8, 0x08, 0x8E);
	idt.createIdtGate(9, (unsigned) _irout9, 0x08, 0x8E);
	idt.createIdtGate(10, (unsigned) _irout10, 0x08, 0x8E);
	idt.createIdtGate(11, (unsigned) _irout11, 0x08, 0x8E);
	idt.createIdtGate(12, (unsigned) _irout12, 0x08, 0x8E);
	idt.createIdtGate(13, (unsigned) _irout13, 0x08, 0x8E);
	idt.createIdtGate(14, (unsigned) _irout14, 0x08, 0x8E);
	idt.createIdtGate(15, (unsigned) _irout15, 0x08, 0x8E);
	idt.createIdtGate(16, (unsigned) _irout16, 0x08, 0x8E);
	idt.createIdtGate(17, (unsigned) _irout17, 0x08, 0x8E);
	idt.createIdtGate(18, (unsigned) _irout18, 0x08, 0x8E);
	idt.createIdtGate(19, (unsigned) _irout19, 0x08, 0x8E);
	idt.createIdtGate(20, (unsigned) _irout20, 0x08, 0x8E);
	idt.createIdtGate(21, (unsigned) _irout21, 0x08, 0x8E);
	idt.createIdtGate(22, (unsigned) _irout22, 0x08, 0x8E);
	idt.createIdtGate(23, (unsigned) _irout23, 0x08, 0x8E);
	idt.createIdtGate(24, (unsigned) _irout24, 0x08, 0x8E);
	idt.createIdtGate(25, (unsigned) _irout25, 0x08, 0x8E);
	idt.createIdtGate(26, (unsigned) _irout26, 0x08, 0x8E);
	idt.createIdtGate(27, (unsigned) _irout27, 0x08, 0x8E);
	idt.createIdtGate(28, (unsigned) _irout28, 0x08, 0x8E);
	idt.createIdtGate(29, (unsigned) _irout29, 0x08, 0x8E);
	idt.createIdtGate(30, (unsigned) _irout30, 0x08, 0x8E);
	idt.createIdtGate(31, (unsigned) _irout31, 0x08, 0x8E);
}

extern "C" void _panicHandler(struct regs *r) {
	if (r->int_no < 32) {
		Video cout;
		cout.clear();
		cout.setPosition(1, 1);

		cout.setColor(0x4F);
		const char kernel_panic[] = "An error occured:";
		cout.print(kernel_panic);

		// TODO print that fuckin message.
		cout.setColor(0x0F);
		cout.print(exception_messages[r->int_no]);

		cout.printChar(' ');
		for (int i = 0; i <= r->int_no; i++) {
			if (i % 5 == 0) {
				cout.printChar(' ');
			}
			cout.printChar('*');
		}

		for (;;)
			;
	}
}
