#include <system/handler/Keyboard.hpp>
#include <system/System.hpp>
#include <idt/InterruptRequests.hpp>

static char buffer[512];
static int bufferedChars = 0;

char Keyboard::readKey() {
        while(bufferedChars == 0) {
                // Warten
        }

        // Zwischenspeichern
        char ret = buffer[--bufferedChars];
        // Aufrutschen
        for(int i = 0; i < bufferedChars; i++) {
                buffer[i] = buffer[i+1];
        }
        // Returnen
        return ret;
}

void Keyboard::keyboardHandler(struct regs *r) {
        unsigned char scancode;

        /* Read from the keyboard's data buffer */
        scancode = inportByte(0x60);

        /* Keycodes */
        char layout[128] = {
                0,  27,
                '1', '2', '3', '4', '5', '6', '7', '8', /* [9] Zahlen */
                '9', '0', '-', '=', '\b',       /* Backspace */
                '\t',                   /* Tab */
                'q', 'w', 'e', 'r',     /* 19 */
                't', 'y', 'u', 'i', 'o', 'p', '[', ']', '\n',   /* Enter key */
                0,                      /* 29   - Control */
                'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', ';',       /* 39 */
                '\'', '`',   0,         /* Left shift */
                '\\', 'z', 'x', 'c', 'v', 'b', 'n',                     /* 49 */
                'm', ',', '.', '/',   0,                                /* Right shift */
                '*',
                0,      /* Alt */
                ' ',    /* Space bar */
                0,      /* Caps lock */
                0,      /* 59 - F1 key ... > */
                0,   0,   0,   0,   0,   0,   0,   0,
                0,      /* < ... F10 */
                0,      /* 69 - Num lock*/
                0,      /* Scroll Lock */
                0,      /* Home kecuy */
                0,      /* Up Arrow */
                0,      /* Page Up */
                '-',
                0,      /* Left Arrow */
                0,
                0,      /* Right Arrow */
                '+',
                0,      /* 79 - End key*/
                0,      /* Down Arrow */
                0,      /* Page Down */
                0,      /* Insert Key */
                0,      /* Delete Key */
                0,   0,   0,
                0,      /* F11 Key */
                0,      /* F12 Key */
                0,      /* All other keys are undefined */
                };

        char layoutchar = layout[scancode];

        if(scancode > 0 && scancode <= 128) {
                buffer[bufferedChars++] = layoutchar;
        }
}

void Keyboard::install(InterruptRequests &requests) {
	Keyboard keyboard;
	requests.installRequestHandler(1, &Keyboard::keyboardHandler);
}
