#include <bios/Video.hpp>
#include <idt/InterruptRequests.hpp>
#include <system/handler/Timer.hpp>

int ticks = 0;
int ticka = 0;

void Timer::timerHandler(struct regs *r) {
	ticks++;

	if (ticks % 9 == 0) {
		Video cout;

		if (ticka < 3) {
			ticka++;
		} else {
			ticka = 0;
		}

		cout.setPosition(78, 1);
		cout.setColor(0x0A);

		switch (ticka) {
		case 0:
			cout.printChar('|');
			break;
		case 1:
			cout.printChar('/');
			break;
		case 2:
			cout.printChar('-');
			break;
		case 3:
			cout.printChar('\\');
			break;
		}
	}
}

void Timer::install(InterruptRequests &requests) {
	Timer timer;
	requests.installRequestHandler(0, &Timer::timerHandler);
}
